##======================##
## Common Task Selector ##
##======================##
	.equ 	TASK_WINDOW_YPOS 	, 	2
	.equ 	TASK_WINDOW_LEFT 	, 	6

task_selector:
	jsr 	restore_vram
task_selector_exec_section: 			## EXEC
tses:
tses_up: 								#UP : TASK SET
	mov 	(flag_up),d0
	cmp 	1,d0
	bne 	tses_dw
	
tses_up_common:
	sub 	d0,d0
	mov 	d0,(flag_sele)
	jsr 	remove_keyin_timer
	jsr 	register_task
	jmp 	tses_end
tses_dw: 								#DW : 
	mov 	(flag_dw),d0
	cmp 	1,d0
	bne 	tses_le
	
	mov 	(ct_dw),d0
	cmp 	0,d0
	bne 	tses_dwd
	
	mov 	1,d0
	mov 	d0,(ct_dw)
	jmp 	tses_end
tses_dwd:
	mov 	(ct_dw),d0
	add 	1,d0
	mov 	d0,(ct_dw)
	
	cmp 	2,d0
	blt 	tses_end


	jsr 	clone_vram
	sub 	d0,d0
	mov 	d0,(flag_sele)
	jsr 	remove_keyin_timer
	jsr 	register_task 				#!
	jsr 	remove_timer
	mov 	1,d0
	mov 	d0,(flag_menu)
	mov 	d0,(flag_pass)
	jmp 	tses_end
tses_le: 								#LE : TASK -- LOOP
	mov 	(flag_le),d0
	cmp 	1,d0
	bne 	tses_ri
	
	jsr 	change_task_dw
	
	sub 	d0,d0
	mov 	d0,(ct_ti)
	mov 	d0,(ct_dw)
	jmp 	tses_end
tses_ri: 								#RI : TASK ++ LOOP
	mov 	(flag_ri),d0
	cmp 	1,d0
	bne 	tses_en
	
	jsr 	change_task_up
	
	sub 	d0,d0
	mov 	d0,(ct_ti)
	mov 	d0,(ct_dw)
	jmp 	tses_end
tses_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	tses_me
	
	jmp 	tses_up_common
tses_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	tses_fi
	
	jsr 	clone_vram
	mov 	1,d0
	mov 	d0,(flag_menu)
	mov 	d0,(flag_pass)
	sub 	d0,d0
	mov 	d0,(flag_sele)
	jsr 	remove_keyin_timer
	jsr 	register_task 				#!
	jsr 	remove_timer
	jmp 	tses_end
tses_fi:
	mov 	(flag_fi),d0
	cmp 	1,d0
	bne 	tses_ti
	
	jsr 	clone_vram
	mov 	1,d0
	mov 	d0,(flag_laun)
	mov 	d0,(flag_pass)
	sub 	d0,d0
	mov 	d0,(flag_sele)
	jsr 	remove_keyin_timer
	jsr 	register_task 				#!
	jsr 	remove_timer
	jmp 	tses_end
tses_ti:
	mov 	(ct_ti),d0
	mov 	(ktim_wait),d1
	cmp 	d1,d0
	blt 	tses_end
	
	sub 	d0,d0
	mov 	d0,(flag_sele)
	jsr 	remove_keyin_timer
	jsr 	register_task
	jmp 	tses_end
tses_end:
	jmp 	task_selector_disp_section
task_selector_disp_section: 			## DISP
tsds:
tsds_window:
	mov 	vram+4+102*TASK_WINDOW_YPOS,a0
	mov 	char_task,a1
	mov 	3,d1
	mov 	TASK_WINDOW_LEFT,d2
	jsr 	win2vram

tsds_icon_calc: 						#calc icon first pos = X
										# A = icon width (= 8)
										# B = icon to icon width (= 4)
										# C = task sum
										# X = C*(A+B)/2
	mov 	(task_list),d3
	mov 	dis_task_list,a0
	sub 	d2,d2
tsds_icon_calc2:
	movbu 	(0,a0),d0
	add 	d0,d2
	add 	1,a0
	add 	-1,d3
	bne 	tsds_icon_calc2
tsds_icon_calc3:
	mov 	(task_list),d0
	sub 	d2,d0 						#d0 <- task sum
	mov 	6,d1
	mulu 	d1,d0
	
	add 	-2,a3
	mov 	d0,(a3) 					#(a3):X

tsds_icon_print:
	mov 	vram+4+53+102*TASK_WINDOW_YPOS+102,a0
	mov 	(a3),d0
	sub 	d0,a0
	mov 	task_list+2,a1
	mov 	(task_list),d3
	sub 	d2,d2
	
tsds_icon_print2:
	mov 	dis_task_list,a2
	movbu 	(d2,a2),d0
	cmp 	1,d0 						#DIS ?
	beq 	tsds_icon_print4
	
	mov 	(0,a1),a2
	movx 	(0,a2),d0
	mov 	d0,a2
	mov 	8,d1
tsds_icon_print3:
	movbu 	(0,a2),d0
	movb 	d0,(0,a0)
	
	add 	1,a0
	add 	1,a2
	add 	-1,d1
	bne 	tsds_icon_print3
	
	add 	4,a0
tsds_icon_print4:
	add 	1,d2
	add 	4,a1
	add 	-1,d3
	bne 	tsds_icon_print2

tsds_icon_reverse:
	mov 	vram+4+52+102*TASK_WINDOW_YPOS+102,a0
	mov 	(a3),d0
	sub 	d0,a0
	mov 	dis_task_list,a2
	mov 	(task_num),d3
	mov 	(task_list),d2
	cmp 	d2,d3
	beq 	tsds_icon_reverse_end
	cmp 	0,d3
	beq 	tsds_icon_reverse_do
tsds_icon_reverse2:
	movbu 	(0,a2),d0
	add 	1,a2
	cmp 	1,d0
	bne 	tsds_icon_reverse3
	add 	-1,d3
	beq 	tsds_icon_reverse_do 		#!
	jmp 	tsds_icon_reverse2
tsds_icon_reverse3:
	add 	12,a0
	add 	-1,d3
	bne 	tsds_icon_reverse2
tsds_icon_reverse_do:
	mov 	10,d1
	jsr 	reverse_area
tsds_icon_reverse_end:

tsds_print_text:
	mov 	(task_num),d3
	mov 	(task_list),d2
	cmp 	d2,d3
	beq 	tsds_print_text_end
	mov 	task_list+2,a2
	cmp 	0,d3
	beq 	tsds_print_text3
tsds_print_text2:
	add 	4,a2
	add 	-1,d3
	bne 	tsds_print_text2
tsds_print_text3:
#	mov 	vram+4,a0
	mov 	vram+4+TASK_WINDOW_LEFT+102*TASK_WINDOW_YPOS+204+4,a0
	mov 	(0,a2),a1
	add 	8,a1
	movx 	(0,a1),d0
	mov 	d0,a1
	jsr 	str2vram
tsds_print_text_end:

tsds_reverse_text:
	mov 	vram+4+TASK_WINDOW_LEFT+102*TASK_WINDOW_YPOS+204+2,a0
	mov 	102-TASK_WINDOW_LEFT*2-4,d1
	jsr 	reverse_area_d

	jmp 	tsds_end
tsds_end:
	add 	2,a3
	
task_selector_end:
ts_end:
	jsr 	lcd_display
	jmp 	clear_section

#########################SUB ROUTINES

#====================
# ChangeTask DW & UP
#====================
#Dis_task_list...

change_task_dw:
	mov 	(task_num),d0
	mov 	(task_list),d1 		#MAX
	cmp 	d1,d0
	beq 	change_task_dw3 		#EGG

	cmp 	0,d0
	beq 	change_task_dw2
	add 	-1,d0
	mov 	d0,(task_num)
	jmp 	change_task_dw_common
change_task_dw2:
	mov 	(task_list),d0
	add 	-1,d0
	mov 	d0,(task_num)
	jmp 	change_task_dw_common
change_task_dw3:
	rts 							#Ignore while egg-ing

change_task_up:
	mov 	(task_num),d0
	mov 	(task_list),d1
	cmp 	d1,d0
	beq 	change_task_up3 		#EGG
	mov 	(task_num),d0
	mov 	(task_list),d1
	add 	-1,d1
	cmp 	d1,d0
	beq 	change_task_up2
	add 	1,d0
	mov 	d0,(task_num)
	jmp 	change_task_up_common
change_task_up2:
	sub 	d0,d0
	mov 	d0,(task_num)
	
	jmp 	change_task_up_common
change_task_up3:
	rts 							#Ignore while egg-ing

change_task_dw_common:
	mov 	(task_num),d1
	mov 	dis_task_list,a0
	movbu 	(d1,a0),d0 				#DIS ?
	cmp 	0,d0
	beq 	change_task_common
	
	jmp 	change_task_dw

change_task_up_common:
	mov 	(task_num),d1
	mov 	dis_task_list,a0
	movbu 	(d1,a0),d0 				#DIS ?
	cmp 	0,d0
	beq 	change_task_common

	jmp 	change_task_up

change_task_common:
	rts

#########################DATA

	char_task: 	.asciz "selector"
